﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using UHF_Reader.Public;
using System.Threading;
using System.IO;

namespace UHF_Reader
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void Main_Load(object sender, EventArgs e)
        {
            string[] serials = new string[32];

            int hidCnt = PublicFunction.SearchHids(ref serials);

            if (hidCnt == 0)
            {
                return;
            }
            else
            {
                for (int i = 0; i < hidCnt; i++)
                {
                    CbCom.Items.Add(serials[i]);
                }
            }

            if (CbCom.Items.Count != 0)
            {
                CbCom.SelectedIndex = 0;
            }
            else
            {
                MessageBox.Show("未搜索到HID");
            }

            /*GetComList();

            if (CbCom.Items.Count != 0)
            {
                CbCom.SelectedIndex = 0;
            }
            else
            {
                MessageBox.Show("错误信息：请确认计算机与读写器正确连接！");
            }*/

            DemoPublic.PublicDM = this;
            timer1.Interval = 200;
            CbQ.SelectedIndex = 3;
        }

        private void BtConnect_Click(object sender, EventArgs e)
        {
            try
            {
                if (BtConnect.Text == "连接")
                {
                    if (CbCom.Items.Count == 0)
                    {
                        MessageBox.Show("未搜索到HID");
                        return;
                    }
                    string comStr = CbCom.SelectedItem.ToString();
                    if (comStr == "")
                    {
                        MessageBox.Show("请选择串口");
                        return;
                    }

                    //PublicFunction.SelectBaudAndCrc(57600, 0x01);

                    if (PublicFunction.ConnectRLM(comStr))
                    {
                        AddToShow("连接成功");
                        BtConnect.Text = "断开";
                        DemoPublic.Enabel_flg = true;
                    }
                    else
                    {
                        AddToShow("连接失败");
                    }
                }
                else
                {
                    if (PublicFunction.DisConnectRLM())
                    {
                        BtConnect.Text = "连接";
                        DemoPublic.Enabel_flg = false;
                        AddToShow("断开成功");
                    }
                    else
                        AddToShow("断开失败");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("异常：" + ex.Message);
            }
        }

        private void BtInventory_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (BtInventory.Text == "盘点标签")
            {
                timer1.Enabled = true; // timer1定时器开启

                DemoPublic.bQ = (byte)CbQ.SelectedIndex;//防碰撞的Q值

                if (PublicFunction.Inventory(0x01, DemoPublic.bQ))
                {
                    DemoPublic.Para para = new DemoPublic.Para();
                                        
                    Object obj = (Object)para;

                    
                    BtInventory.Text = "停止";

                    DemoPublic.LoopEnable = true;

                  //  DemoPublic.EPCThread = new Thread(new ParameterizedThreadStart(PublicFunction.GetUiiThread_Timer));
                    DemoPublic.EPCThread =new Thread (  PublicFunction.GetUiiThread_Timer);//EPC线程，执行GetUiiThread_Timer方法

                    DemoPublic.EPCThread.IsBackground = true;

                    DemoPublic.EPCThread.Start(obj);

                    AddToShow("盘点标签已开启");
                }
                else
                {
                    AddToShow("盘点标签失败");
                    BtInventory.Text = "盘点标签";
                }
            }
            else
            {
                timer1.Enabled = false;
                DemoPublic.LoopEnable = false;

                if (PublicFunction.Stop())
                {
                    BtInventory.Text = "盘点标签";
                    AddToShow("盘点标签已关闭");
                }
                else
                {
                    AddToShow("停止盘点失败");
                }
            }
        }

        private void BtReadTid_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (BtReadTid.Text == "读取TID")
            {
                AddToShow("读取TID已开启");

                timer1.Enabled = true;

                byte[] Uii = new byte[64];
                byte[] pwd = { 0x00, 0x00, 0x00, 0x00 };
                DemoPublic.Para para = new DemoPublic.Para();
                para.bank = 0x02;
                para.pwd = pwd;
                para.addr = (int)NumUDAddr.Value;
                para.len = (int)NumUDLen.Value;

                if (ChkBox_withuii.Checked)
                {
                    string uiiStr = TbUii.Text.ToString().Trim();

                    if (!DemoPublic.CheckDigit(uiiStr))
                    {
                        MessageBox.Show("UII请输入16进制的数据");
                        return;
                    }
                    DemoPublic.HexStringToBytes(uiiStr, Uii);
                    para.withuii = true;
                    para.uii = Uii;
                }
                else
                {
                    para.withuii = false;
                    para.uii = Uii;
                }
                
                Object obj = (Object)para;

                BtReadTid.Text = "停止";

                DemoPublic.LoopEnable = true;

                DemoPublic.EPCThread = new Thread(new ParameterizedThreadStart(PublicFunction.ReadDataThread_Timer));

                DemoPublic.EPCThread.IsBackground = true;

                DemoPublic.EPCThread.Start(obj);

            }
            else
            {
                timer1.Enabled = false;
                DemoPublic.LoopEnable = false;

                BtReadTid.Text = "读取TID";
                AddToShow("读取TID已关闭");
            }
        }

        private void BtReadUser_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (BtReadUser.Text == "读取USER")
            {
                AddToShow("读取USER已开启");

                timer1.Enabled = true;

                byte[] Uii = new byte[64];
                DemoPublic.Para para = new DemoPublic.Para();
                para.bank = 0x03;
                para.pwd = new byte[4];
                para.addr = (int)NumUDAddr.Value;
                para.len = (int)NumUDLen.Value;

                if (ChkBox_withuii.Checked)
                {
                    string uiiStr = TbUii.Text.ToString().Trim();

                    if (!DemoPublic.CheckDigit(uiiStr))
                    {
                        MessageBox.Show("UII请输入16进制的数据");
                        return;
                    }
                    DemoPublic.HexStringToBytes(uiiStr, Uii);
                    para.withuii = true;
                    para.uii = Uii;
                }
                else
                {
                    para.withuii = false;
                    para.uii = Uii;
                }

                Object obj = (Object)para;

                BtReadUser.Text = "停止";

                DemoPublic.LoopEnable = true;

                DemoPublic.EPCThread = new Thread(new ParameterizedThreadStart(PublicFunction.ReadDataThread_Timer));

                DemoPublic.EPCThread.IsBackground = true;

                DemoPublic.EPCThread.Start(obj);

            }
            else
            {
                timer1.Enabled = false;
                DemoPublic.LoopEnable = false;

                BtReadUser.Text = "读取USER";
                AddToShow("读取USER已关闭");
            }
        }

        private void BtWriteEPC_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            byte[] pwd = { 0x00, 0x00, 0x00, 0x00 };
            byte[] uii = new byte[64];
            byte[] uiilen = new byte[1];
            byte[] writedata = new byte[256];
            byte[] error = new byte[1];
            byte[] writelen = new byte[1];
            byte cnt = 0;

            if (ChkBox_withuii.Checked)
            {
                string uiiStr = TbUii.Text.ToString().Trim();

                if (!DemoPublic.CheckDigit(uiiStr))
                {
                    MessageBox.Show("UII请输入16进制的数据");
                    return;
                }
                DemoPublic.HexStringToBytes(uiiStr, uii);
            }

            string tempStr = TbData.Text.ToString().Trim();

            if (tempStr == "")
            {
                MessageBox.Show("请输入数据");
                return;
            }

            string dataStr = tempStr.Replace(" ", "");
            if (RbHanzi.Checked)
            {
                dataStr = DemoPublic.HanziToUnicodeHexString(dataStr);
            }
            cnt = (byte)(dataStr.Length / 4);
            DemoPublic.HexStringToBytes(dataStr, writedata);

            if (ChkBox_withuii.Checked)
            {
                if (PublicFunction.WriteEPC(pwd, cnt, uii, writedata, error, writelen))
                {
                    System.Media.SystemSounds.Asterisk.Play();

                    AddToShow("指定标签更改EPC成功");
                    if (cbxAdd1.Checked && RbHex.Checked)
                    {
                        cbxHexSum1.CheckState = CheckState.Unchecked;
                        cbxAdd1.Checked = true;
                        this.TbData.Text = strinc(TbData.Text, 10); //10进制加1
                    }
                     if (cbxHexSum1.Checked && RbHex.Checked)
                    {
                        cbxAdd1.CheckState = CheckState.Unchecked;
                        cbxHexSum1.Checked = true;
                        this.TbData.Text = strinc(TbData.Text, 16); //16进制加1
                    }
                }
                else 
                {
                    AddToShow("指定标签更改EPC失败");
                }
            }
            else 
            {
                if (PublicFunction.WriteEPCSingle(pwd, cnt, uii, uiilen, writedata, error, writelen))
                {
                    System.Media.SystemSounds.Asterisk.Play();

                    AddToShow("不指定标签更改EPC成功");

                    //if (cbxAdd1.CheckState == CheckState.Checked)
                    //{
                    //    cbxHexSum1.Enabled = false;
                    //    this.TbData.Text = strinc(TbData.Text, 10); //10进制加1
                    //}
                    if (cbxAdd1.Checked && RbHex.Checked)
                    {
                       
                        cbxAdd1.Checked = true;
                        this.TbData.Text = strinc(TbData.Text, 10); //10进制加1
                    }
                    if (cbxHexSum1.Checked && RbHex.Checked)
                    {
                      
                        cbxHexSum1.Checked = true;
                        this.TbData.Text = strinc(TbData.Text, 16); //16进制加1
                    }
                }
                else
                {
                    AddToShow("不指定标签更改EPC失败");
                }
            }
            
        }

        private void BtWriteData_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (BtWriteData.Text == "写入USER")
            {
                AddToShow("写入USER已开启");
                byte[] pwd = { 0x00, 0x00, 0x00, 0x00 };
                byte len = 0x00;
                byte[] Uii = new byte[64];
                byte[] writedata = new byte[256];

                string tempStr = TbData.Text.ToString().Trim();

                if (tempStr == "")
                {
                    MessageBox.Show("请输入数据");
                    return;
                }

                string dataStr = tempStr.Replace(" ", "");
                Console.WriteLine("dataStr:" + dataStr);
                if (RbHanzi.Checked)
                {
                    dataStr = DemoPublic.HanziToUnicodeHexString(dataStr);
                }
                Console.WriteLine("--dataStr:"+dataStr);
                len = (byte)(dataStr.Length / 4);
                DemoPublic.HexStringToBytes(dataStr, writedata);
                Console.WriteLine("writedata:" + writedata[0] + " " + writedata[1]);

                DemoPublic.Para para = new DemoPublic.Para();
                para.pwd = pwd;
                para.uii = Uii;
                para.len = len;
                para.writedata = writedata;

                if (ChkBox_withuii.Checked)
                {
                    string uiiStr = TbUii.Text.ToString().Trim();

                    if (!DemoPublic.CheckDigit(uiiStr))
                    {
                        MessageBox.Show("UII请输入16进制的数据");
                        return;
                    }
                    DemoPublic.HexStringToBytes(uiiStr, Uii);
                    para.withuii = true;
                    para.uii = Uii;
                }
                else
                {
                    para.withuii = false;
                    para.uii = Uii;
                }
                
                Object obj = (Object)para;

                timer1.Enabled = true;
                BtWriteData.Text = "停止";

                DemoPublic.LoopEnable = true;

                DemoPublic.EPCThread = new Thread(new ParameterizedThreadStart(PublicFunction.WriteDataThread_Timer));

                DemoPublic.EPCThread.IsBackground = true;

                DemoPublic.EPCThread.Start(obj);
            }
            else
            {
                timer1.Enabled = false;
                DemoPublic.LoopEnable = false;

                BtWriteData.Text = "写入USER";
                AddToShow("写入USER已关闭");

                if (DemoPublic.EPCThread != null)
                {
                    DemoPublic.EPCThread.Abort();
                }
            }
            
        }

        private void BtClear_Click(object sender, EventArgs e)
        {
            
        }

        private void BtSave_Click(object sender, EventArgs e)
        {
            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            DemoPublic.TagThread tagThread = new DemoPublic.TagThread(Public.DemoPublic.ShowLoop);
            DemoPublic.PublicDM.BeginInvoke(tagThread);
        }

        private void TbData_TextChanged(object sender, EventArgs e)
        {
            if (RbHex.Checked)
            {
                string tempStr = TbData.Text.ToString().Trim().Replace(" ", "");

                string resStr = DataCheck(tempStr);

                TbData.Text = resStr;

                TbData.SelectionStart = resStr.Length;
            }
            else 
            {
                string tempStr = TbData.Text.ToString().Trim().Replace(" ", "");
                string resStr = "";

                for (int i = 0; i < tempStr.Length; i++)
                {
                    resStr += tempStr[i] + " ";
                }

                TbData.Text = resStr;

                TbData.SelectionStart = resStr.Length;
            }
        }

        private void TbData_Leave(object sender, EventArgs e)
        {
            if (RbHex.Checked)
            {
                string tempStr = TbData.Text.ToString().Trim().Replace(" ", "");
                string resStr = DataCheck(tempStr);
                if (tempStr.Length % 4 == 1)
                {
                    resStr = tempStr + "000";
                }
                else if (tempStr.Length % 4 == 2)
                {
                    resStr = tempStr + "00";
                }
                else if (tempStr.Length % 4 == 3)
                {
                    resStr = tempStr + "0";
                }

                TbData.Text = resStr;

                TbData.SelectionStart = resStr.Length;
            }
        }

        private void TbData_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 0x08)
            {
                string tempStr = TbData.Text.ToString();

                int len = tempStr.Length;

                if (len > 0 && tempStr.Substring(len - 1) == " ")
                {
                    tempStr = tempStr.Substring(0, len - 1);

                    TbData.Text = tempStr;

                    TbData.SelectionStart = tempStr.Length;
                }
            }
        }

        private string DataCheck(string str)
        {
            string tempStr = "";
            string resStr = "";

            char[] c = str.ToUpper().ToCharArray();
            for (int i = 0; i < c.Length; i++)
            {
                if (System.Text.RegularExpressions.Regex.IsMatch((c[i]).ToString(), "[0-9]") || System.Text.RegularExpressions.Regex.IsMatch((c[i]).ToString(), "[A-F]"))
                {
                    tempStr += c[i];
                }
            }

            for (int i = 0; i < tempStr.Length; i++)
            {
                resStr += tempStr[i];
                if ((i + 1) % 4 == 0)
                {
                    resStr += " ";
                }
            }

            return resStr;
        }

        public void GetComList()
        {
            RegistryKey keyCom = Registry.LocalMachine.OpenSubKey("Hardware\\DeviceMap\\SerialComm");
            if (keyCom != null)
            {
                string[] sSubKeys = keyCom.GetValueNames();
                this.CbCom.Items.Clear();
                foreach (string sName in sSubKeys)
                {
                    string sValue = (string)keyCom.GetValue(sName);
                    this.CbCom.Items.Add(sValue);
                }
            }
        }

        public void AddToShow(string str)
        {
            TbShow.AppendText(str + "\r\n");
        }

        private void DataGVTags_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            /*try
            {
                if (e.RowIndex >= 0)
                {  
                  //TbUii.Text = DataGVTags.Rows[e.RowIndex].Cells[2].Value.ToString()
                    TbUii.Text = DataGVTags.Rows[e.RowIndex].Cells[2].Value.ToString()+DataGVTags.Rows[e.RowIndex].Cells[3].Value.ToString();

                    if (DataGVTags.CurrentCellAddress.X == 10)
                    {
                        if (!(bool)DataGVTags.Rows[e.RowIndex].Cells[10].EditedFormattedValue)
                        {
                            string userStr = "";
                            string user_Str = DataGVTags.Rows[e.RowIndex].Cells[6].Value.ToString().Trim();

                            if (user_Str != "")
                            {
                                userStr = DemoPublic.UnicodeHexStringToHanzi(user_Str);

                                DataGVTags.Rows[e.RowIndex].Cells[10].Value = false;
                                DataGVTags.Rows[e.RowIndex].Cells[6].Selected = true;
                                MessageBox.Show("" + userStr);

                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {

            }*/

            try
            {
                long startTime = Environment.TickCount;

                if (e.RowIndex >= 0)
                {
                    //TbUii.Text = DataGVTags.Rows[e.RowIndex].Cells[2].Value.ToString();
                    TbUii.Text = DataGVTags.Rows[e.RowIndex].Cells[2].Value.ToString() + DataGVTags.Rows[e.RowIndex].Cells[3].Value.ToString();

                    if (DataGVTags.CurrentCellAddress.X == 10)
                    {
                        if (!(bool)DataGVTags.Rows[e.RowIndex].Cells[10].EditedFormattedValue)
                        {
                            string userStr = "";
                            string user_Str = DataGVTags.Rows[e.RowIndex].Cells[6].Value.ToString().Trim();

                            if (user_Str != "")
                            {
                                userStr = DemoPublic.UnicodeHexStringToHanzi(user_Str);
                                DataGVTags.Rows[e.RowIndex].Cells[6].Value = userStr;
                            }
                        }
                        else
                        {
                            string userStr = "";
                            string user_Str = DataGVTags.Rows[e.RowIndex].Cells[6].Value.ToString().Trim();

                            if (user_Str != "")
                            {
                                userStr = DemoPublic.HanziToUnicodeHexString(user_Str);
                                DataGVTags.Rows[e.RowIndex].Cells[6].Value = userStr;
                            }
                        }
                    }
                }

                Thread.Sleep(1);
                long timeSpan = Environment.TickCount - startTime;
                Console.WriteLine("TimeSpan = " + timeSpan);
            }
            catch (Exception ex)
            {

            }
        }

        private void RbHanzi_CheckedChanged(object sender, EventArgs e)
        {
            if (RbHanzi.Checked)
            {
                string hexStr = TbData.Text.ToString().Trim().Replace(" ", "");

                string hanziStr = DemoPublic.UnicodeHexStringToHanzi(hexStr);

                TbData.Text = hanziStr;
            }
        }

        private void RbHex_CheckedChanged(object sender, EventArgs e)
        {
            if (RbHex.Checked)
            {
                string hanziStr = TbData.Text.ToString().Trim().Replace(" ", "");

                string hexStr = DemoPublic.HanziToUnicodeHexString(hanziStr);

                TbData.Text = hexStr;
            }
        }

        private void BtCloseBeep_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (!PublicFunction.SetBeep(false))
            {
                MessageBox.Show("关闭蜂鸣器失败");
                return;
            }
            Thread.Sleep(200);
            if (!PublicFunction.SaveReg())
            {
                MessageBox.Show("保存蜂鸣器失败");
                return;
            }
            AddToShow("关闭蜂鸣器成功");
        }

        private void BtOpenBeep_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (!PublicFunction.SetBeep(true))
            {
                MessageBox.Show("打开蜂鸣器失败");
                return;
            }
            Thread.Sleep(200);
            if (!PublicFunction.SaveReg())
            {
                MessageBox.Show("保存蜂鸣器失败");
                return;
            }
            AddToShow("打开蜂鸣器成功");
        }

        private void ToolSMIConfig_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            Settings settings = new Settings();

            settings.Show();
        }

        private void ToolSMIUpdate_Click(object sender, EventArgs e)
        {
            FmUpdate fmUpdate = new FmUpdate();
            fmUpdate.Show();
        }

        private void ToolSMIVersion_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            string infoStr = "";
            byte[] bSerial = new byte[6];
            byte[] bVersion = new byte[3];
            if (PublicFunction.GetVersion(bSerial, bVersion))
            {
                infoStr += "硬件序列号：" + DemoPublic.BytesToHexString(bSerial, 6) + "\n";
                infoStr += "软件版本号：" + bVersion[0].ToString() + "." + bVersion[1].ToString() + "." + bVersion[2].ToString() + "\n";
            }
            else
            {
                infoStr += "读取硬件序列号和软件版本号失败\n";
            }

            /*byte[] Uid = new byte[12];
            if (PublicFunction.ReadUID(Uid))
            {
                infoStr += "产品UID：" + DemoPublic.BytesToHexString(Uid, 12);
            }
            else
            {
                infoStr += "读取UID失败\n";
            }*/

            MessageBox.Show(infoStr, "产品信息");
        }

        private void ToolSMIExit_Click(object sender, EventArgs e)
        {
            DialogResult dr = MessageBox.Show("确定要退出系统吗？",
                "温馨提示",
                MessageBoxButtons.YesNo,
                MessageBoxIcon.Information,
                MessageBoxDefaultButton.Button1);

            if (dr == DialogResult.Yes)
            {
                if (DemoPublic.Enabel_flg)
                {
                    PublicFunction.Stop();
                }
                Application.Exit();
            }
        }

        private void ToolSMIClear_Click(object sender, EventArgs e)
        {
            DataGVTags.Rows.Clear();
            DataGVTags.Refresh();
            DemoPublic.tagList.Clear();
            DemoPublic.uiiList.Clear();
            DemoPublic.CntToZero();
            TbTagCnt.Text = "0";
            TbShow.Text = "";
        }

        private void ToolSMISave_Click(object sender, EventArgs e)
        {
            string stFilePath = Application.StartupPath.Trim() + "\\Record-" + DateTime.Now.ToString("yyyy-MM-dd-hh-mm-ss") + ".txt";
            StreamWriter swStream;
            string str = "";

            if (File.Exists(stFilePath))
            {
                swStream = new StreamWriter(stFilePath);
            }
            else
            {
                swStream = File.CreateText(stFilePath);
            }

            for (int i = 0; i < DataGVTags.Rows.Count; i++)
            {
                for (int j = 0; j < DataGVTags.Columns.Count; j++)
                {
                    string _strTemp = DataGVTags.Rows[i].Cells[j].Value.ToString();
                    
                    str += _strTemp + "\0";
                }

                swStream.WriteLine(str);
                str = "";
            }

            //关闭流,释放资源
            swStream.Flush();
            swStream.Close();
            //导入Txt文件后,自动打开文件
            System.Diagnostics.Process.Start("notepad.exe", stFilePath);
        }

        private void BtInventorySingle_Click(object sender, EventArgs e)
        {
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            byte[] uiiLen = new byte[1];
            byte[] uii = new byte[64];

            if (!PublicFunction.InventorySingle(uiiLen, uii))
            {
                AddToShow("单步盘点失败");
                return;
            }
            string uiiStr = DemoPublic.BytesToHexString(uii, uiiLen[0]);
            AddToShow("单步盘点成功，UII为：" + uiiStr);

            DemoPublic.tagInfo.type = "盘点";
            DemoPublic.tagInfo.uii = uiiStr;
            DemoPublic.tagInfo.pc = uiiStr.Substring (0,4);
            DemoPublic.tagInfo.epc = uiiStr.Substring (4);
            DemoPublic.tagInfo.tid = "";
            DemoPublic.tagInfo.user = "";
            DemoPublic.tagInfo.err = "";

            if (!DemoPublic.uiiList.Contains(uiiStr))
            {
                DemoPublic.uiiList.Add(uiiStr);
            }

            int index = DemoPublic.tagList.IndexOf(DemoPublic.tagInfo);
            if (index == -1)
            {
                DemoPublic.tagList.Add(DemoPublic.tagInfo);
                int indexs = DemoPublic.tagList.IndexOf(DemoPublic.tagInfo);
                DemoPublic.cnt[indexs] = 1;
            }
            else
            {
                DemoPublic.cnt[index]++;
            }

            DemoPublic.TagThread tagThread = new DemoPublic.TagThread(DemoPublic.ShowLoop);
            DemoPublic.PublicDM.BeginInvoke(tagThread);
        }

        private void BtInventorySingleLoop_Click(object sender, EventArgs e)
        { 
            if (!DemoPublic.Enabel_flg)
            {
                MessageBox.Show("请先进行连接");
                return;
            }

            if (BtInventorySingleLoop.Text == "循环盘点")
            {
                timer1.Enabled = true;
                
                BtInventorySingleLoop.Text = "停止";

                DemoPublic.LoopEnable = true;
                DemoPublic.EPCThread = new Thread(new ThreadStart(PublicFunction.GetUiiSingleLoopThread_Timer));
                DemoPublic.EPCThread.IsBackground = true;
                DemoPublic.EPCThread.Start();
                AddToShow("循环盘点标签已开启");
            }
            else
            {
                timer1.Enabled = false;
                DemoPublic.LoopEnable = false;
                BtInventorySingleLoop.Text = "循环盘点";
                AddToShow("循环盘点标签已关闭");
            }
        }

        private void cBxshowHanzi_CheckedChanged(object sender, EventArgs e)
        {
            if (this.cBxshowHanzi.Checked == true)
            {
                DemoPublic.number = 0;

            }
            else DemoPublic.number = 1;
        }
        /// <summary>
        /// 16进制+1 
        /// </summary>
        /// <param name="s1"></param>
        /// <param name="hex"></param>
        /// <returns></returns>
        private string strinc(string s1, int hex)
        {
            string str, newstr;
            int index = 0;
            int newInt;
            str = s1.Trim().Replace(" ", "");
            str = str.ToUpper();
            if (hex == 10)
            {
                for (int i = str.Length - 1; i > 0; i--)
                {
                    if (str[i] != (char)57)
                    {
                        index = i;
                        break;
                    }
                }
                newInt = Convert.ToInt32(str.Substring(index)) + 1;
                str = str.Substring(0, index) + newInt.ToString();
            }
             if (hex == 16)
            {
                newstr = "";
                for (int i = str.Length - 1; i > 0; i--)
                {
                    if (str[i] == (char)57)
                    {
                        newstr = "A";
                        index = i;
                        break;
                    }
                    else if (str[i] != (char)70)
                    {
                        newstr = Chr(Asc(str.Substring(i, 1)) + 1);
                        index = i;
                        break;
                    }
                }
                str = str.Substring(0, index) + newstr + str.Substring(index + 1).Replace("F", "0");
            }

            return str;
        }    //OVER
        private string Chr(int asciiCode)
        {
            if (asciiCode >= 0 && asciiCode <= 255)
            {
                System.Text.ASCIIEncoding asciiEncoding = new System.Text.ASCIIEncoding();
                byte[] byteArray = new byte[] { (byte)asciiCode };
                string strCharacter = asciiEncoding.GetString(byteArray);
                return (strCharacter);
            }
            else
            {
                throw new Exception("ASCII Code is not valid.");
            }
        }
        private int Asc(string character)
        {
            if (character.Length == 1)
            {
                System.Text.ASCIIEncoding asciiEncoding = new System.Text.ASCIIEncoding();
                int intAsciiCode = (int)asciiEncoding.GetBytes(character)[0];
                return (intAsciiCode);
            }
            else
            {
                throw new Exception("Character is not valid.");
            }

        }

        private void cbxAdd1_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxAdd1.Checked)
            {  
                this.cbxHexSum1.Enabled = false;
            }
            else this.cbxHexSum1.Enabled = true;
        }

        private void cbxHexSum1_CheckedChanged(object sender, EventArgs e)
        {
            if (cbxHexSum1.Checked)
            {
                this.cbxAdd1.Enabled = false;
            }
            else this.cbxAdd1.Enabled = true;
        }
    }
}