﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using UHF_Reader.Public;

namespace UHF_Reader
{
    public partial class Settings : Form
    {
        public Settings()
        {
            InitializeComponent();
        }

        private void Settings_Load(object sender, EventArgs e)
        {
            //读取功率
            byte[] bPower = new byte[1];
            if (PublicFunction.GetPower(bPower))
            {
                TbPower.Text = Convert.ToString(bPower[0]);
                trackBarPower.Value = bPower[0];
                AddTxt("读取功率成功, 功率为：" + (bPower[0]) + "dBm");
            }
            else
            {
                AddTxt("读取功率失败");
            }
            //读取频率
            Thread.Sleep(200);

            byte[] bFreMode = new byte[1];
            byte[] bBaseFre = new byte[2];
            byte[] bFreBase = new byte[1];
            byte[] bFreChannel = new byte[1];
            byte[] bFreSpc = new byte[1];
            byte[] bFreHop = new byte[1];
            if (PublicFunction.GetFrequency(bFreMode, bFreBase, bBaseFre, bFreChannel, bFreSpc, bFreHop))
            {
                int startI = 0, startD = 0, space = 0, endI = 0, endD = 0;

                startI = (bBaseFre[0] << 3) + (bBaseFre[1] >> 5);
                if (bFreBase[0] == 0)
                {
                    startD = 50 * (bBaseFre[1] & 0x1F);
                    space = 50 * bFreSpc[0] * (bFreChannel[0] - 1);
                }
                else
                {
                    startD = 125 * (bBaseFre[1] & 0x1F);
                    space = 125 * bFreSpc[0] * (bFreChannel[0] - 1);
                }

                endI = startI + (startD + space) / 1000;
                endD = (startD + space) % 1000;

                string freStr = startI + "." + startD + " - " + endI + "." + endD + " MHz";

                AddTxt("读取频率成功, \r\n频率为：" + freStr);

                if (bFreHop[0] == 0)
                    CbHop.SelectedIndex = 0;
                else if (bFreHop[0] == 1)
                    CbHop.SelectedIndex = 1;
                else
                    CbHop.SelectedIndex = 2;

                if (bFreMode[0] == 0)
                {
                    CbFre.SelectedIndex = 0;
                }
                else if (bFreMode[0] == 1)
                {
                    CbFre.SelectedIndex = 1;
                }
                else if (bFreMode[0] == 2)
                {
                    CbFre.SelectedIndex = 2;
                }
                else
                {
                    if (freStr == "902.750 - 927.750 MHz")
                        CbFre.SelectedIndex = 3;
                    else if (freStr == "922.750 - 927.750 MHz")
                        CbFre.SelectedIndex = 4;
                    else if (freStr == "917.300 - 920.900 MHz")
                        CbFre.SelectedIndex = 5;
                    else if (freStr == "902.750 - 906.750 MHz")
                        CbFre.SelectedIndex = 6;
                    else if (freStr == "915.750 - 927.750 MHz")
                        CbFre.SelectedIndex = 7;
                }
            }
            else
            {
                AddTxt("读取功率失败");
            }
        }

        private void BtSetPower_Click(object sender, EventArgs e)
        {
            byte[] bPower = new byte[1];
            byte power = (byte)trackBarPower.Value;

            if (PublicFunction.SetPower(power))
            {
                AddTxt("设置功率成功");

                Thread.Sleep(200);

                if (PublicFunction.GetPower(bPower))
                {
                    TbPower.Text = Convert.ToString(bPower[0]);
                    trackBarPower.Value = bPower[0];
                    AddTxt("读取功率成功, 功率为：" + (bPower[0]) + "dBm");
                }
                else
                {
                    AddTxt("读取功率失败");
                }
            }
            else
            {
                AddTxt("设置功率失败");
            }
        }

        private void BtSetFre_Click(object sender, EventArgs e)
        {
            int freStyle = CbFre.SelectedIndex;
            byte FreHop = (byte)CbHop.SelectedIndex;
            byte FreMode = 0x04;
            byte[] bBaseFre = new byte[2];
            byte FreBase = 0x01;
            byte FreChannel = 0x15;
            byte FreSpc = 0x02;

            byte[] bFreMode = new byte[1];
            byte[] bFreBase = new byte[1];
            byte[] bFreChannel = new byte[1];
            byte[] bFreSpc = new byte[1];
            byte[] bFreHop = new byte[1];

            switch (freStyle)
            {
                case 0://China 920-925 MHz
                    FreMode = 0x00;
                    FreBase = 0x00;
                    FreChannel = 0x00;
                    FreSpc = 0x00;
                    bBaseFre[0] = 0x00;
                    bBaseFre[1] = 0x00;
                    /*FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x14;
                    FreSpc = 0x02;
                    bBaseFre[0] = 0x73;
                    bBaseFre[1] = 0x01;*/
                    break;
                case 1://China 840-845 MHz
                    FreMode = 0x01;
                    FreBase = 0x00;
                    FreChannel = 0x00;
                    FreSpc = 0x00;
                    bBaseFre[0] = 0x00;
                    bBaseFre[1] = 0x00;
                    /*FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x14;
                    FreSpc = 0x02;
                    bBaseFre[0] = 0x69;
                    bBaseFre[1] = 0x01;*/
                    break;
                case 2://ETSI 865-868 MHz
                    FreMode = 0x02;
                    FreBase = 0x00;
                    FreChannel = 0x00;
                    FreSpc = 0x00;
                    bBaseFre[0] = 0x00;
                    bBaseFre[1] = 0x00;
                    break;
                case 3://FCC 902-928 MHz
                    FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x33;
                    FreSpc = 0x04;
                    bBaseFre[0] = 0x70;
                    bBaseFre[1] = 0xC6;
                    break;
                case 4://Taiwan 922-928 MHz
                    FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x0B;
                    FreSpc = 0x04;
                    bBaseFre[0] = 0x73;
                    bBaseFre[1] = 0x46;
                    break;
                case 5://Korea 917-921 MHz
                    FreMode = 0x04;
                    FreBase = 0x00;
                    FreChannel = 0x07;
                    FreSpc = 0x0C;
                    bBaseFre[0] = 0x72;
                    bBaseFre[1] = 0xA6;
                    break;
                case 6://Brazil 902-907 MHz
                    FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x09;
                    FreSpc = 0x04;
                    bBaseFre[0] = 0x70;
                    bBaseFre[1] = 0xC6;
                    break;
                case 7://Brazil 915-928 MHz
                    FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x19;
                    FreSpc = 0x04;
                    bBaseFre[0] = 0x72;
                    bBaseFre[1] = 0x66;
                    break;
                case 8://Brazil 913-917 MHz
                    FreMode = 0x04;
                    FreBase = 0x01;
                    FreChannel = 0x09;
                    FreSpc = 0x04;
                    bBaseFre[0] = 0x72;
                    bBaseFre[1] = 0x20;
                    break;
                default:
                    break;
            }

            if (PublicFunction.SetFrequency(FreMode, FreBase, bBaseFre, FreChannel, FreSpc, FreHop))
            {
                AddTxt("设置频率成功");

                Thread.Sleep(200);

                if (PublicFunction.GetFrequency(bFreMode, bFreBase, bBaseFre, bFreChannel, bFreSpc, bFreHop))
                {
                    int startI = 0, startD = 0, space = 0, endI = 0, endD = 0;

                    startI = (bBaseFre[0] << 3) + (bBaseFre[1] >> 5);
                    if (bFreBase[0] == 0)
                    {
                        startD = 50 * (bBaseFre[1] & 0x1F);
                        space = 50 * bFreSpc[0] * (bFreChannel[0] - 1);
                    }
                    else
                    {
                        startD = 125 * (bBaseFre[1] & 0x1F);
                        space = 125 * bFreSpc[0] * (bFreChannel[0] - 1);
                    }

                    endI = startI + (startD + space) / 1000;
                    endD = (startD + space) % 1000;

                    string freStr = startI + "." + startD + " - " + endI + "." + endD + " MHz";

                    AddTxt("读取频率成功, \r\n频率为：" + freStr);
                }
                else
                {
                    AddTxt("读取功率失败");
                }

            }
            else
            {
                AddTxt("设置频率失败");
            }
        }

        private void trackBarPower_Scroll(object sender, EventArgs e)
        {
            TbPower.Text = Convert.ToString(trackBarPower.Value);
        }

        private void AddTxt(string txt)
        {
            TbShow.AppendText(txt + "\r\n");
        }
 
    }
}